/*

  File Integrali.ccp:

  Calcola l'integrale di una funzione tramite la regola dei trapezi o la regola di Cavalieri-Simpson

*/


#include "Integrali.h"


/*
  Funzione Trapezi
  calcola l'integrale di una funzione nota su N+1 punti
  con la regola dei trapezi
*/

double Trapezi( double f[], double h, long N )
{
  double sum;

  sum = 0.5 * ( f[0] + f[N] );
  for ( long i = 1; i < N; i++ ) sum += f[i];
  return( h * sum );
}


/*
  Funzione Simpson
  calcola l'integrale di una funzione nota su N+1 punti
  (N pari) con la regola di Cavalieri-Simpson
*/


double Simpson( double f[], double h, long N )
{
  double sump = 0.0, sumd = 0.0;

  for ( long i = 2; i <= N - 2; i = i + 2 ) sump += f[i];
  for ( long i = 1; i <= N - 1; i = i + 2 ) sumd += f[i];
  return( ( h / 3.0 ) * ( f[0] + f[N] + 2.0 * sump + 4.0 * sumd ));
}
