/*

  File simpson.ccp:

  Calcola l'integrale di una funzione tramite la regola di Cavalieri-Simpson

*/


#include <iostream>
#include <cmath>
#include "Integrali.h"

using namespace std;


// Funzioni da integrare e intervallo di integrazione

#define F( x ) exp( x )                        // Funzione
#define a     0.0                              // Estremo sinistro
#define b     2.0                              // Estremo destro
#define Fint( a, b ) ( exp( b ) - exp( a ) )   // Integrale


int main()
{
  cout << "Calcolo dell\'integrale definito di una funzione" << endl;

  long N;
  cout << "Numero di intervalli su cui calcolare l\'integrale: ";
  cin >> N;

  try {
     if ( ( N % 2 ) != 0 ) throw "Errore: il numero dei punti deve essere pari...";
     }
  catch ( char const * str ) {
     cout << str << endl;
     return 0;
     }


  // Definisce la funzione sui punti nodali

  double x;
  double *f = new double( N + 1 );
  double dx = ( b - a ) / N;

  for ( long i = 0; i <= N; i++ )
    {
      x    = a + i * dx;
      f[i] = F( x );
    }


  // Calcolo dell'integrale definito

  double Inum = Simpson( f, dx, N );
  double Iex  = Fint( a, b );


  // Stampa del risultato

  cout.precision(15);
  cout << "Risultato integrazione numerica: I_num = " << Inum << endl;
  cout << "Valore esatto dell\'integrale: I_ex = " << Iex << endl;
  cout << "Errore: abs( I_ex  - I_num ) = " << abs( Iex - Inum ) << endl;

  return 0;
}
